﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WG_TemplateAddRowAddValidRow
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();

            dt.Columns.Add("id", typeof(int)).AutoIncrement = true;
            dt.Columns.Add("Name", typeof(string));
            dt.Columns.Add("Description", typeof(string));

            dt.Rows.Add(new object[] { null, "Row 1", "Description" });
            dt.Rows.Add(new object[] { null, "Row 2", "Description" });
            dt.Rows.Add(new object[] { null, "Row 3", "Description" });
            dt.Rows.Add(new object[] { null, "Row 4", "Description" });

            ultraGrid1.DataSource = dt;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.AllowAddNew = Infragistics.Win.UltraWinGrid.AllowAddNew.TemplateOnTop;
        }

        private void ultraGrid1_InitializeTemplateAddRow(object sender, Infragistics.Win.UltraWinGrid.InitializeTemplateAddRowEventArgs e)
        {
            e.TemplateAddRow.Cells["Name"].Value = "Row " + ultraGrid1.Rows.Count;
        }

        private void ultraGrid1_BeforeExitEditMode(object sender, Infragistics.Win.UltraWinGrid.BeforeExitEditModeEventArgs e)
        {
            if (ultraGrid1.ActiveCell.Column.Key == "Description")
            {
                e.Cancel =String.IsNullOrEmpty(ultraGrid1.ActiveCell.Text)
                    || ultraGrid1.ActiveCell.Text.Any(char.IsDigit);

                if (e.Cancel)
                    MessageBox.Show("The value shoudn't be null or containing number");

                
            }
        }
    }
}
